diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/examples/reference/generate_bianchi.m ns-3.34/src/wifi/examples/reference/generate_bianchi.m
--- ns-3.33/src/wifi/examples/reference/generate_bianchi.m	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/examples/reference/generate_bianchi.m	2021-07-14 10:31:07.000000000 -0700
@@ -1,426 +1,456 @@
-clear;
-
-%11a DIFS
-fid = fopen('bianchi_11a_difs.txt', 'wt');
-nA = [5:5:50];
-
-%6Mbps
-data_rate = 6e6;
-ack_rate = 6e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
-fprintf(fid, "// 6 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%9Mbps
-data_rate = 9e6;
-ack_rate = 6e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
-fprintf(fid, "// 9 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%12Mbps
-data_rate = 12e6;
-ack_rate = 12e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
-fprintf(fid, "// 12 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%18Mbps
-data_rate = 18e6;
-ack_rate = 12e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
-fprintf(fid, "// 18 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%24Mbps
-data_rate = 24e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
-fprintf(fid, "// 24 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%36Mbps
-data_rate = 36e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
-fprintf(fid, "// 36 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%48Mbps
-data_rate = 48e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
-fprintf(fid, "// 48 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%54Mbps
-data_rate = 54e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
-fprintf(fid, "// 54 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-fclose(fid);
-
-%11a EIFS
-fid = fopen('bianchi_11a_eifs.txt', 'wt');
-
-%6Mbps
-data_rate = 6e6;
-ack_rate = 6e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
-fprintf(fid, "// 6 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%9Mbps
-data_rate = 9e6;
-ack_rate = 6e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
-fprintf(fid, "// 9 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%12Mbps
-data_rate = 12e6;
-ack_rate = 12e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
-fprintf(fid, "// 12 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%18Mbps
-data_rate = 18e6;
-ack_rate = 12e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
-fprintf(fid, "// 18 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%24Mbps
-data_rate = 24e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
-fprintf(fid, "// 24 Mbps - TC with EIFS\n");
-for k=1:10
-fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%36Mbps
-data_rate = 36e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
-fprintf(fid, "// 36 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%48Mbps
-data_rate = 48e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
-fprintf(fid, "// 48 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%54Mbps
-data_rate = 54e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
-fprintf(fid, "// 54 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-fclose(fid);
-
-
-%11g DIFS
-fid = fopen('bianchi_11g_difs.txt', 'wt');
-
-%6Mbps
-data_rate = 6e6;
-ack_rate = 6e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
-fprintf(fid, "// 6 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%9Mbps
-data_rate = 9e6;
-ack_rate = 6e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
-fprintf(fid, "// 9 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%12Mbps
-data_rate = 12e6;
-ack_rate = 12e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
-fprintf(fid, "// 12 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%18Mbps
-data_rate = 18e6;
-ack_rate = 12e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
-fprintf(fid, "// 18 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%24Mbps
-data_rate = 24e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
-fprintf(fid, "// 24 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%36Mbps
-data_rate = 36e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
-fprintf(fid, "// 36 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%48Mbps
-data_rate = 48e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
-fprintf(fid, "// 48 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%54Mbps
-data_rate = 54e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
-fprintf(fid, "// 54 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-fclose(fid);
-
-%11g EIFS
-fid = fopen('bianchi_11g_eifs.txt', 'wt');
-
-%6Mbps
-data_rate = 6e6;
-ack_rate = 6e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
-fprintf(fid, "// 6 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%9Mbps
-data_rate = 9e6;
-ack_rate = 6e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
-fprintf(fid, "// 9 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%12Mbps
-data_rate = 12e6;
-ack_rate = 12e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
-fprintf(fid, "// 12 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%18Mbps
-data_rate = 18e6;
-ack_rate = 12e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
-fprintf(fid, "// 18 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%24Mbps
-data_rate = 24e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
-fprintf(fid, "// 24 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%36Mbps
-data_rate = 36e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
-fprintf(fid, "// 36 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%48Mbps
-data_rate = 48e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
-fprintf(fid, "// 48 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%54Mbps
-data_rate = 54e6;
-ack_rate = 24e6;
-[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
-fprintf(fid, "// 54 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-fclose(fid);
-
-
-%11b DIFS
-fid = fopen('bianchi_11b_difs.txt', 'wt');
-
-%1Mbps
-txduration = 12480e-6;
-ack = 304e-6;
-[bianchi_result] = Bianchi11b(txduration, ack, 1);
-fprintf(fid, "// 1 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%2Mbps
-txduration = 6336e-6;
-ack = 248e-6;
-[bianchi_result] = Bianchi11b(txduration, ack, 1);
-fprintf(fid, "// 2 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%5.5Mbps
-txduration = 2427e-6;
-ack = 248e-6;
-[bianchi_result] = Bianchi11b (txduration, ack, 1);
-fprintf(fid, "// 5.5 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%11Mbps
-txduration = 1310e-6;
-ack = 248e-6;
-[bianchi_result] = Bianchi11b (txduration, ack, 1);
-fprintf(fid, "// 11 Mbps - TC with DIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%11b EIFS
-fid = fopen ('bianchi_11b_eifs.txt', 'wt');
-
-%1Mbps
-txduration = 12480e-6;
-ack = 304e-6;
-[bianchi_result] = Bianchi11b (txduration, ack, 0);
-fprintf (fid, "// 1 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf (fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf (fid, "\n");
-
-%2Mbps
-txduration = 6336e-6;
-ack = 248e-6;
-[bianchi_result] = Bianchi11b(txduration, ack, 0);
-fprintf(fid, "// 2 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%5.5Mbps
-txduration = 2427e-6;
-ack = 248e-6;
-[bianchi_result] = Bianchi11b(txduration, ack, 0);
-fprintf(fid, "// 5.5 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
-
-%11Mbps
-txduration = 1310e-6;
-ack = 248e-6;
-[bianchi_result] = Bianchi11b(txduration, ack, 0);
-fprintf(fid, "// 11 Mbps - TC with EIFS\n");
-for k=1:10
-    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
-end
-fprintf(fid, "\n");
+% Copyright 2020 University of Washington
+% 
+% Redistribution and use in source and binary forms, with or without
+% modification, are permitted provided that the following conditions are met:
+% 
+% 1. Redistributions of source code must retain the above copyright notice,
+% this list of conditions and the following disclaimer.
+% 
+% 2. Redistributions in binary form must reproduce the above copyright notice,
+% this list of conditions and the following disclaimer in the documentation
+% and/or other materials provided with the distribution.
+% 
+% 3. Neither the name of the copyright holder nor the names of its contributors
+% may be used to endorse or promote products derived from this software without
+% specific prior written permission.
+% 
+% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
+% AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+% IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+% ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+% LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+% CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+% SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+% INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+% CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+% ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+% POSSIBILITY OF SUCH DAMAGE.
+%
+% Co-authored by Leonardo Lanante, Hao Yin, and Sebastien Deronne
+
+clear;
+
+%11a DIFS
+fid = fopen('bianchi_11a_difs.txt', 'wt');
+nA = [5:5:50];
+
+%6Mbps
+data_rate = 6e6;
+ack_rate = 6e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
+fprintf(fid, "// 6 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%9Mbps
+data_rate = 9e6;
+ack_rate = 6e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
+fprintf(fid, "// 9 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%12Mbps
+data_rate = 12e6;
+ack_rate = 12e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
+fprintf(fid, "// 12 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%18Mbps
+data_rate = 18e6;
+ack_rate = 12e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
+fprintf(fid, "// 18 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%24Mbps
+data_rate = 24e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
+fprintf(fid, "// 24 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%36Mbps
+data_rate = 36e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
+fprintf(fid, "// 36 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%48Mbps
+data_rate = 48e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
+fprintf(fid, "// 48 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%54Mbps
+data_rate = 54e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 1);
+fprintf(fid, "// 54 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+fclose(fid);
+
+%11a EIFS
+fid = fopen('bianchi_11a_eifs.txt', 'wt');
+
+%6Mbps
+data_rate = 6e6;
+ack_rate = 6e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
+fprintf(fid, "// 6 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%9Mbps
+data_rate = 9e6;
+ack_rate = 6e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
+fprintf(fid, "// 9 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%12Mbps
+data_rate = 12e6;
+ack_rate = 12e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
+fprintf(fid, "// 12 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%18Mbps
+data_rate = 18e6;
+ack_rate = 12e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
+fprintf(fid, "// 18 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%24Mbps
+data_rate = 24e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
+fprintf(fid, "// 24 Mbps - TC with EIFS\n");
+for k=1:10
+fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%36Mbps
+data_rate = 36e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
+fprintf(fid, "// 36 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%48Mbps
+data_rate = 48e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
+fprintf(fid, "// 48 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%54Mbps
+data_rate = 54e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11a(data_rate, ack_rate, 0);
+fprintf(fid, "// 54 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+fclose(fid);
+
+
+%11g DIFS
+fid = fopen('bianchi_11g_difs.txt', 'wt');
+
+%6Mbps
+data_rate = 6e6;
+ack_rate = 6e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
+fprintf(fid, "// 6 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%9Mbps
+data_rate = 9e6;
+ack_rate = 6e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
+fprintf(fid, "// 9 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%12Mbps
+data_rate = 12e6;
+ack_rate = 12e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
+fprintf(fid, "// 12 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%18Mbps
+data_rate = 18e6;
+ack_rate = 12e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
+fprintf(fid, "// 18 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%24Mbps
+data_rate = 24e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
+fprintf(fid, "// 24 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%36Mbps
+data_rate = 36e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
+fprintf(fid, "// 36 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%48Mbps
+data_rate = 48e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
+fprintf(fid, "// 48 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%54Mbps
+data_rate = 54e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 1);
+fprintf(fid, "// 54 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+fclose(fid);
+
+%11g EIFS
+fid = fopen('bianchi_11g_eifs.txt', 'wt');
+
+%6Mbps
+data_rate = 6e6;
+ack_rate = 6e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
+fprintf(fid, "// 6 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%9Mbps
+data_rate = 9e6;
+ack_rate = 6e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
+fprintf(fid, "// 9 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%12Mbps
+data_rate = 12e6;
+ack_rate = 12e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
+fprintf(fid, "// 12 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%18Mbps
+data_rate = 18e6;
+ack_rate = 12e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
+fprintf(fid, "// 18 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%24Mbps
+data_rate = 24e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
+fprintf(fid, "// 24 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%36Mbps
+data_rate = 36e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
+fprintf(fid, "// 36 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%48Mbps
+data_rate = 48e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
+fprintf(fid, "// 48 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%54Mbps
+data_rate = 54e6;
+ack_rate = 24e6;
+[bianchi_result] = Bianchi11g(data_rate, ack_rate, 0);
+fprintf(fid, "// 54 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+fclose(fid);
+
+
+%11b DIFS
+fid = fopen('bianchi_11b_difs.txt', 'wt');
+
+%1Mbps
+txduration = 12480e-6;
+ack = 304e-6;
+[bianchi_result] = Bianchi11b(txduration, ack, 1);
+fprintf(fid, "// 1 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%2Mbps
+txduration = 6336e-6;
+ack = 248e-6;
+[bianchi_result] = Bianchi11b(txduration, ack, 1);
+fprintf(fid, "// 2 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%5.5Mbps
+txduration = 2427e-6;
+ack = 248e-6;
+[bianchi_result] = Bianchi11b (txduration, ack, 1);
+fprintf(fid, "// 5.5 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%11Mbps
+txduration = 1310e-6;
+ack = 248e-6;
+[bianchi_result] = Bianchi11b (txduration, ack, 1);
+fprintf(fid, "// 11 Mbps - TC with DIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%11b EIFS
+fid = fopen ('bianchi_11b_eifs.txt', 'wt');
+
+%1Mbps
+txduration = 12480e-6;
+ack = 304e-6;
+[bianchi_result] = Bianchi11b (txduration, ack, 0);
+fprintf (fid, "// 1 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf (fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf (fid, "\n");
+
+%2Mbps
+txduration = 6336e-6;
+ack = 248e-6;
+[bianchi_result] = Bianchi11b(txduration, ack, 0);
+fprintf(fid, "// 2 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%5.5Mbps
+txduration = 2427e-6;
+ack = 248e-6;
+[bianchi_result] = Bianchi11b(txduration, ack, 0);
+fprintf(fid, "// 5.5 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
+
+%11Mbps
+txduration = 1310e-6;
+ack = 248e-6;
+[bianchi_result] = Bianchi11b(txduration, ack, 0);
+fprintf(fid, "// 11 Mbps - TC with EIFS\n");
+for k=1:10
+    fprintf(fid, "        {%d, %.4f},\n", nA(k), bianchi_result(k));
+end
+fprintf(fid, "\n");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/examples/wifi-bianchi.cc ns-3.34/src/wifi/examples/wifi-bianchi.cc
--- ns-3.33/src/wifi/examples/wifi-bianchi.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/examples/wifi-bianchi.cc	2021-07-14 10:31:07.000000000 -0700
@@ -28,6 +28,7 @@
 #include "ns3/log.h"
 #include "ns3/config.h"
 #include "ns3/gnuplot.h"
+#include "ns3/boolean.h"
 #include "ns3/string.h"
 #include "ns3/double.h"
 #include "ns3/integer.h"
@@ -47,6 +48,8 @@
 #include "ns3/packet-socket-client.h"
 #include "ns3/packet-socket-server.h"
 #include "ns3/application-container.h"
+#include "ns3/ampdu-subframe-header.h"
+#include "ns3/wifi-mac.h"
 
 #define PI 3.1415926535
 
